//+------------------------------------------------------------------+
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"


#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  Green
#property indicator_color2  Red
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1


//
//
//
//
//

extern string TimeFrame       = "current time frame";
extern int    AtrPeriod       = 14;
extern int    AtrMa_Mode      = 1;
extern int    MaPeriod        = 14;
extern int    Ma_Mode         = 1;
extern bool   ShowText        = true;
extern string TextDir         = "atrma Text";
extern int    textXPosition   = 5;
extern int    textYPosition   = 30;
extern color  tradeTextColor  = Green;
extern color  waitTextColor   = Gray;
extern int    tradeFontSize   = 12;
extern int    waitFontSize    = 12;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";



//
//
//
//
//

double UpH[];
double DnH[]; 
double atr[];
double atrma[];
double temp[];
double trend[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,UpH); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,DnH); SetIndexStyle(1,DRAW_HISTOGRAM);  
   SetIndexBuffer(2,atr);
   SetIndexBuffer(3,atrma);
   SetIndexBuffer(4,temp);
   SetIndexBuffer(5,trend);
   
   //
   //
   //
   //
   //
     
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
 

   //
   //
   //
   //
   //
         
   IndicatorShortName(timeFrameToString(timeFrame)+"  Atr Ma ("+AtrPeriod+","+MaPeriod+")");
return(0);
}
int deinit() 
{  
   ObjectDelete(TextDir);
return(0); 
}


//
//
//
//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { UpH[0] = limit+1; return(0); }


   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {     
     for (i=limit; i>=0; i--)   temp[i] = MathMax(High[i],Close[i+1]) - MathMin(Low[i],Close[i+1]);
     for (i=limit; i>=0; i--) { atr[i]  = iMAOnArray(temp,Bars,AtrPeriod,0,AtrMa_Mode,i);  } 
     for (i=limit; i>=0; i--)   
     {
         atrma[i] = iMAOnArray(atr,Bars,MaPeriod,0,Ma_Mode,i); 
         UpH[i]   = EMPTY_VALUE;
         DnH[i]   = EMPTY_VALUE;
         trend[i] = trend[i+1];
         if(atr[i]>atrma[i]) { trend[i] = 1; Commenter(1);  }
         if(atr[i]<atrma[i]) { trend[i] =-1; Commenter(-1); }
         if (trend[i] == 1) UpH[i] = 1;
         if (trend[i] ==-1) DnH[i] = 1;
     }
     manageAlerts(); 
   return(0);
   }
     
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         UpH[i] = EMPTY_VALUE;
         DnH[i] = EMPTY_VALUE;
         trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",AtrPeriod,AtrMa_Mode,MaPeriod,Ma_Mode,ShowText,TextDir,textXPosition,textYPosition,tradeTextColor,waitTextColor,tradeFontSize,waitFontSize,5,y); 
            if (trend[i]== 1) UpH[i] = 1; 
            if (trend[i]==-1) DnH[i] = 1; 
   }
manageAlerts();    
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+  
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert(whichBar,"volatility increasing");
         else  doAlert(whichBar,"volatility decreasing");       
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

           message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Atr_Ma ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Atr_Ma"),message);
          if (alertsSound)   PlaySound("alert2.wav");
      }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M2","M3","M4","M5","M6","M7","M8","M9","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,2,3,4,5,6,7,8,9,10,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//
//
//
//
//

void Commenter(int Dir) 
{
    if (ShowText)
    {
      ObjectCreate(TextDir,OBJ_LABEL,0,0,0);
         ObjectSet(TextDir,OBJPROP_XDISTANCE,textXPosition);
         ObjectSet(TextDir,OBJPROP_YDISTANCE,textYPosition);
         if (Dir == 1) ObjectSetText(TextDir, "Trade", tradeFontSize,"Arial Black",tradeTextColor);
         if (Dir ==-1) ObjectSetText(TextDir, "Wait",  waitFontSize, "Arial Black",waitTextColor);
    }
}